import requests, re, json, os
import koding
import __builtin__
import xbmc, xbmcaddon
from koding import route
from resources.lib.plugin import Plugin
from resources.lib.util.context import get_context_items
from resources.lib.util.xml import JenItem, JenList, display_list
from unidecode import unidecode
from datetime import datetime, timedelta
import calendar
from jetextractors import extractors
from dateutil import tz

CACHE_TIME = 0  # change to wanted cache time in seconds

addon_fanart = xbmcaddon.Addon().getAddonInfo('fanart')
addon_icon = xbmcaddon.Addon().getAddonInfo('icon')
user_agent = 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/63.0.3239.84 Safari/537.36'

class jetextractor(Plugin):
    name = "jetextractor"

    def process_item(self, item_xml):
        if "<jetextractor>" in item_xml:
            item = JenItem(item_xml)
            extractor = item.get("jetextractor", "")
            result_item = {
                'label': item["title"],
                'icon': item.get("thumbnail", addon_icon),
                'fanart': item.get("fanart", addon_fanart),
                'mode': "jetextractor_games",
                'url': extractor,
                'folder': True,
                'imdb': "0",
                'season': "0",
                'episode': "0",
                'info': {},
                'year': "0",
                'context': get_context_items(item),
                "summary": item.get("summary", None)
            }
            result_item["properties"] = {
                'fanart_image': result_item["fanart"]
            }
            result_item['fanart_small'] = result_item["fanart"]
            return result_item

def format_time(date):
    return utc_to_local(date).strftime("%m/%d %I:%M %p") if date != "" else ""

def format_links(links):
    res = []
    for link in links:
        res.append("<sublink>jetextractor://%s</sublink>" % link)
    return "".join(res)

# https://stackoverflow.com/questions/4563272/convert-a-python-utc-datetime-to-a-local-datetime-using-only-python-standard-lib
def utc_to_local(utc_dt):
    timestamp = calendar.timegm(utc_dt.timetuple())
    local_dt = datetime.fromtimestamp(timestamp)
    assert utc_dt.resolution >= timedelta(microseconds=1)
    return local_dt.replace(microsecond=utc_dt.microsecond)

@route(mode="jetextractor_games", args=["url"])
def get_games(url):
    pins = ""
    xml = ""
    for module in extractors.__all__:
        if hasattr(module, "site_name") and hasattr(module, "get_games") and url == module.site_name:
            games = module.get_games()
            for game in games:
                xml += "<item>"\
                    "<title>[COLORblue]%s[COLORwhite] |[B][I] %s[/B][/I]\n [COLORred]%s[/COLOR]</title>"\
                    "<meta>"\
                    "<content>movie</content>"\
                    "<imdb></imdb>"\
                    "<title></title>"\
                    "<year></year>"\
                    "<thumbnail>%s</thumbnail>"\
                    "<fanart>%s</fanart>"\
                    "<summary>%s</summary>"\
                    "</meta>"\
                    "<link>"\
                    "%s"\
                    "</link>"\
                    "</item>" % (game["league"], game["title"], format_time(game["time"]), game["icon"], game["icon"], game["title"], format_links(game["links"]))
    jenlist = JenList(xml)
    display_list(jenlist.get_list(), jenlist.get_content_type(), pins)


